<?php
/**
 * Created by PhpStorm.
 * User: zhuangxin
 * Date: 16-9-13
 * Time: 下午5:01
 */

namespace App\Article\Listeners;

use App\Article\Events\ArtAddEvent;
use App\Article\Events\ArtEditedEvent;
use App\Member\Model\User as UserModel;
use App\Headline\Model\HeadLine;
use App\Libraries\ElasticSearch\Search;
use App\Article\Model\Art as ArtModel;

class ArtListener
{

    public function handle($event)
    {
        $model = $event->model;
        try {
            if ($event instanceof ArtAddEvent) {
                $role = UserModel::getUserRole($model->uid);
                if ($role !== false) {
                    if ($role == UserModel::ROLE_PHOTOGRAPHER) {
                        HeadLine::add(HeadLine::PHOTOGRAPHER_ARTICLE_PUBLISH, [
                            'photographer' => UserModel::getUserInfo($model->uid,["nickname"])->nickname,
                            'article' => $model->title,
                            'target' => $model->id
                        ]);
                    }
                    if ($role == UserModel::ROLE_MASTER) {
                        HeadLine::add(HeadLine::MASTER_ARTICLE_PUBLISH, [
                            'master' => UserModel::getUserInfo($model->uid,["nickname"])->nickname,
                            'article' => $model->title,
                            'target' => $model->id
                        ]);
                    }
                }
            }
            $searcher = Search::getSearcher();
            if ($model->is_del == 1 || $model->is_hidden == 1 || $model->exists == false) {
                $searcher->del(Search::ART , $model->id);
            } elseif ($model->is_del == 0 && $model->is_hidden == 0) {
                $searcher->save(Search::ART , $model->id , [
                    "article_id" => $model->id,
                    "title" => $model->title,
                    "kw" => implode(" ",array_column($model->relation_keywords()->get("kw")->toArray(),"kw")),
                    "nickname" =>  UserModel::getUserInfo($model->uid,["nickname"])->nickname,
                    "lasttime" => date("Y-m-d H:i:s")
                ]);
            }
        } catch (\Exception $e) {
            return;
        }
    }
}