<?php

namespace App\Article\Validation;
use App\Http\Validation\ValidatorBase as Validator;

class ArtValidator extends Validator
{
    protected $validator = [
        'title'          =>  'required|chinese_length:2,50',
        'cover'          =>  'required',
        'content'        =>  'required'
    ];

    protected $message  = [
        'title.required'            =>  '需要输入标题',
        'title.chinese_lenth'       =>  '标题限制为2到50个字符',
        'cover.required'            =>  '请添加封面',
        'content.required'          =>  '请输入内容',
    ];

    /**
     * 额外规则
     * @param array $data
     */
    public function custom_validate($data)
    {
        $messages = [];
        if (!empty($data['keywords'])) {
            foreach($data['keywords'] as $keyword) {
                if(mb_strlen($keyword,"utf8") > 4) {
                    $messages[] = "关键词: \"".$keyword."\" 应小于4个字";
                    break;
                }
            }
        }
        return $messages;
    }

}