<?php


namespace App\Cates\Controller;

use App\Http\Response\Response;
use App\Traits\Controller;
use App\Cates\Model\Cates as CategoryModel;
class Category extends \Illuminate\Routing\Controller
{

    use Controller;

    protected $query_fields = [
        "previous","kw_name","is_del","sort"
    ];

    public function index()
    {
        $query = request()->query();
        $where = $this->filter($query);
        $model = $this->setBlurSearch(CategoryModel::class,$where,"category_name");
        is_null($where) && $where = [];
        $row  = isset($query["size"])?$query["size"]:config("app.default_perpage");
        return Response::success($model->where('is_del',0)->paginate($row)->toArray());
    }

    public function child($id)
    {
        $data = CategoryModel::where('is_del',0)->where('previous',$id)->get()->toArray();
        return Response::success($data);
    }

    public function pretty()
    {
        $data = CategoryModel::where('is_del',0)->get()->toArray();
        $data = $this->list_to_tree($data,"id","previous");
        return Response::success($data);
    }

    protected function list_to_tree($list, $pk='id', $pid = 'pid', $child = 'child', $root = 0) {
        $tree = array();
        if(is_array($list)) {
            $refer = array();
            foreach ($list as $key => $data) {
                $refer[$data[$pk]] =& $list[$key];
            }
            foreach ($list as $key => $data) {
                $parentId =  $data[$pid];
                if ($root == $parentId) {
                    $tree[] =& $list[$key];
                }else{
                    if (isset($refer[$parentId])) {
                        $parent =& $refer[$parentId];
                        $parent[$child][] =& $list[$key];
                    }
                }
            }
        }
        return $tree;
    }
}
