<?php

namespace App\City\Controller;

use Illuminate\Routing\Controller;
use App\City\Model\City as CityModel;
use App\City\Model\Travel as TravelModel;
use App\Http\Response\Response;

class City extends Controller
{
    use \App\Traits\Controller;
    protected $query_fields = [
        "is_open","is_hot","previous","name","abroad"
    ];

    public function index()
    {
        $query = request()->query();
        $where = $this->filter($query);
        $model = $this->setBlurSearch(CityModel::class,$where,"name");
        return  Response::success($model->get()->toArray());
    }

    public function parent($id)
    {
        try {
            $info = CityModel::findOrFail($id);
            $pid = $info->previous;
            $parent = CityModel::findOrFail($pid);
            return Response::success($parent->toArray());
        } catch (ModelNotFoundException $e){
            return Response::error(HttpStatus::HttpNotFound,"城市未找到");
        }
    }

    public function show($id)
    {
        try {
            $info = CityModel::findOrFail($id);
            return Response::success($info->toArray());
        } catch (ModelNotFoundException $e){
            return Response::error(HttpStatus::HttpNotFound,"城市未找到");
        }
    }

    public function travel()
    {
        $query = request()->query();
        $where = $this->filter($query);
        $model = $this->setBlurSearch(TravelModel::class,$where,"name");
        return  Response::success($model->get()->toArray());
    }

}
