<?php
/**
 * Created by PhpStorm.
 * User: zhuangxin
 * Date: 16-9-20
 * Time: 下午2:09
 */
namespace  App\City\Model;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Cache;

class City extends Model
{
     protected $table = "myp_site";

     //存储、更新地点缓存
    public static function getPlace ($id,$forceUpdate = false) {
          $key = base64_encode("place-".$id);
          if(!Cache::has($key) || $forceUpdate == true) {
               Cache::put($key,self::where('id',$id)->get());
          }
          return Cache::get($key);
     }

     public static function getPlaceName ($id,$field = "name") {
          if (empty($id)) {
               return "";
          }
          $cache = self::getPlace($id);
          if (empty($cache)) {
               return $id;
          }
          return $cache->$field;
     }



     public static function getPlaceParent($id) {
          if (empty($id)) {
               return "";
          }
          return self::getPlaceName(self::getPlaceName($id,"previous"));
     }

     public static function getPlaceRoot($id) {
          if (empty($id)) {
               return "";
          }
          while (self::getPlace($id)->level != 0) {
               $id = self::getPlaceRoot(self::getPlace($id)->previous);
          }
          return $id;
     }

     public static function getChina()
     {
          return 1;
     }

     public static function list_to_tree($list, $pk='id', $pid = 'pid', $child = 'child', $root = 0) {
          // 创建Tree
          $tree = array();
          if(is_array($list)) {
               // 创建基于主键的数组引用
               $refer = array();
               foreach ($list as $key => $data) {
                    $refer[$data[$pk]] =& $list[$key];
               }
               foreach ($list as $key => $data) {
                    // 判断是否存在parent
                    $parentId =  $data[$pid];
                    if ($root == $parentId) {
                         $tree[] =& $list[$key];
                    }else{
                         if (isset($refer[$parentId])) {
                              $parent =& $refer[$parentId];
                              $parent[$child][] =& $list[$key];
                         }
                    }
               }
          }
          return $tree;
     }

}