<?php

namespace App\Headline\Model;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class HeadLine extends Model
{

    const IDENT_PASS = 1;
    const SETS_PUBLISH = 2;
    const PHOTOGRAPHER_ARTICLE_PUBLISH = 3;
    const OPEN_NEW_CITY = 4;
    const MASTER_ARTICLE_PUBLISH = 5;
    const SETS_RECOMMEND = 6;

    const TITLE = [
        self::IDENT_PASS => "摄影师通过认证",
        self::SETS_PUBLISH => "发布套系",
        self::PHOTOGRAPHER_ARTICLE_PUBLISH => "摄影师发布攻略",
        self::OPEN_NEW_CITY => "开通新城市",
        self::MASTER_ARTICLE_PUBLISH => "达人发布攻略",
        self::SETS_RECOMMEND => "推荐套系"
    ];

    const TEMPLATE = [
        self::IDENT_PASS => "摄影师「{photographer}」入驻约拍啦",
        self::SETS_PUBLISH => "摄影师「{photographer}」添加了新套系「{sets}」",
        self::PHOTOGRAPHER_ARTICLE_PUBLISH => "摄影师「{photographer}」发布了新攻略「{article}」",
        self::OPEN_NEW_CITY => "约拍开通了新服务城市「{city}」",
        self::MASTER_ARTICLE_PUBLISH => "达人「{master}」发布了新攻略「{article}」",
        self::SETS_RECOMMEND => "「{photographer}」的套系「{sets}」被太多人喜欢啦"
    ];


    protected $table = "myp_headline";

    //解析字符串
    protected static function parse($action,$data) {
        if (!array_key_exists($action,self::TEMPLATE)) {
            return false;
        }
        $str = self::TEMPLATE[$action];
        if (key_exists("photographer",$data)) {
            $str = str_replace("{photographer}",$data['photographer'],$str);
        }

        if (key_exists("sets",$data)) {
            $str = str_replace("{sets}",$data['sets'],$str);
        }

        if (key_exists("article",$data)) {
            $str = str_replace("{article}",$data['article'],$str);
        }

        if (key_exists("city",$data)) {
            $str = str_replace("{city}",$data['city'],$str);
        }

        if (key_exists("master",$data)) {
            $str = str_replace("{master}",$data['master'],$str);
        }
        return $str;
    }

    //新增
    public static function add($action,$data)
    {
        $str = static::parse($action,$data);
        if ($str === false) {
            return false;
        }
        $content = [
            'content' => $str,
            'type'    => $action
        ];
        if (isset($data['target'])) {
            $content['target'] =  $data['target'];
        }
        $instance = new self();
        return $instance->save($content);
    }
}