<?php

namespace App\Http\Validation;
use Illuminate\Support\Facades\Validator;

class ValidatorBase extends Validator
{
    //加_以免和父类重名
    protected $_message  = [];
    public static $_validator;
    public static $_result;
    /**
     * @return boolean
     */
    public function validate(array $post)
    {
        self::$_validator = self::make($post,$this->validator,$this->message);
        if (self::$_validator->passes()) {
            if (method_exists($this, "custom_validate")) {
                $res = call_user_func_array([$this, "custom_validate"], [$post]);
                if (!empty($res)) {
                    $this->_message = $res;
                    self::$_result =  false;
                } else {
                    self::$_result =  true;
                }
            } else {
                self::$_result =  true;
            }
        } else {
            self::$_result =  false;
        }
        return self::$_result;
    }

    /**
     * @return array
     */
    public function getMessages()
    {
        $messages = [];
        if (self::$_result == false) {
            foreach(self::$_validator->messages()->toArray() as $message) {
                $messages = array_merge($messages,$message);
            }
            return array_merge($messages,$this->_message);
        } else {
            return [];
        }
    }

}