<?php

namespace App\Ident\Controller;

use App\Http\Response\HttpStatus;
use App\Ident\Validation\IdentValidator;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use App\Http\Response\Response;
use App\Ident\Model\Ident as IdentModel;
use App\Member\Model\User as UserModel;

class Ident extends Controller
{

    use \App\Traits\Controller;
    /**
     * 申请认证
     * method  post
     * route /ident/:uid
     */
    public function store(Request $request)
    {
        if (IdentModel::isApplied(request('id'))) {
            return Response::error("用户已认证或正在审核中",HttpStatus::HttpForbidden);
        }
        $validator = new IdentValidator();
        $post = $request->all();
        isset($post['device']) && $post['device'] = json_encode($post['device']);
        isset($post['glory']) &&  $post['glory'] = json_encode($post['glory']);
        isset($post['web_url']) && $post['web_url'] = json_encode($post['web_url']);
        isset($post['org']) && $post['org'] = json_encode($post['org']);
        $vali = $validator->validate($post);
        if($vali == false){
            return Response::error($validator->getMessages(),HttpStatus::HttpValidationFailed);
        };
        if(count(UserModel::getUserIdsByNickname(trim($post['nickname']))) > 0) {
            return Response::error("这个昵称已经被使用了");
        }
        $model = new IdentModel();
        $res = $model->save($post);
        if ($res === true) {
            return Response::ok();
        } else {
            return Response::error();
        }
    }



}