<?php

namespace App\Ident\Model;

use App\Traits\Models;
use Illuminate\Database\Eloquent\Model;

class Ident extends Model
{
    use Models;
    protected $table = "myp_photographer_ident";
    public $timestamps = false;

    public function __construct(array $attributes = [])
    {
        parent::__construct($attributes);
        $this->beforeValidationOnCreate();
        $this->skipAttributesOnUpdate();
    }

    /**
     * 引入的PHALCON风格的函数
     */
    public function beforeValidationOnCreate()
    {
        $this->card_photo = " ";
    }

    /**
     * 引入的PHALCON风格的函数
     */
    public function skipAttributesOnUpdate()
    {
        $this->guard([
            'card_photo'
            ]);
    }

    /**
     * 是否已申请过
     */
    public static function isApplied($uid)
    {
        return self::whereIn('checked_status',[1,2])->where('uid',$uid)->get(['id'])->count() >= 1;
    }
}