<?php

namespace App\Ident\Validation;

use App\Http\Validation\ValidatorBase as Validator;

class IdentValidator extends Validator
{
    protected $validator = [
        'city'          =>  'required',
        'card_handle'   =>  'required',
        'alipay_account'=>  'required',
        'ex'            =>  'required|array_length_min:5|array_length_max:5',
        'styles'        =>  'required',
        'wx_open_id'    =>  'required',
        'introduce'     =>  'chinese_length:2,50',
        'nickname'      =>  'required',
        'sex'           =>  'required',
        'work_experince'=>  'required',
        'device'        =>  'required',
        'name'          =>  'required',
        'card_id'       =>  'required',
    ];

    protected $message  = [
        'city.required'             =>  '请选择您的城市',
        'introduce.chinese_lenth'   =>  '个人简介应为2到50个字符',
        'card_handle.required'      =>  '请上传您的手持证件照',
        'alipay_account.required'   =>  '您必须填写支付宝账号',
        'ex.required'               =>  '你必须上传您的代表作品',
        'styles.required'           =>  '请选择您擅长的分类',
        'wx_open_id.required'       =>  '您还未绑定微信号',
        'sex.required'              =>  '请选择性别',
        'work_experince.required'   =>  '请填写您的从业年限',
        'device.required'           =>  '请填写您的拍摄器材',
        'name.required'             =>  '姓名不能为空',
        'card_id.required'          =>  '身份证号不能为空',
        'ex.array_length_min'       =>  '代表作品限制为5张',
        'ex.array_length_max'       =>  '代表作品限制为5张',
        "introduce.chinese_length"  =>  '个人简介应为2到50个字',
        "nickname.required"         =>  '请传入昵称'
    ];


}