<?php
namespace App\Kw\Controller;
use App\Http\Response\Response;
use App\Kw\Model\Keywords as KeywordsModel;
use App\Traits\Controller;

class Keywords extends \Illuminate\Routing\Controller
{
    use Controller;
    protected $query_fields = [
        "join_hot","kw_name","is_del"
    ];

    public function index()
    {
        $query = request()->query();
        $where = $this->filter($query);
        $model = $this->setBlurSearch(KeywordsModel::class,$where,"kw_name");
        is_null($where) && $where = [];
        $row  = isset($query["size"])?$query["size"]:config("app.default_perpage");
        return Response::success($model->paginate($row)->toArray());
    }

    public function show($id)
    {
        try {
            $info = KeywordsModel::findOrFail($id);
            return Response::success($info->toArray());
        } catch (ModelNotFoundException $e){
            return Response::error(HttpStatus::HttpNotFound,"未找到");
        }
    }


}
