<?php

namespace App\Kw\Model;

use App\Traits\Models;
use Illuminate\Database\Eloquent\Model;

class Keywords extends Model
{
    use Models;
    protected $table = "myp_kw";
    public $timestamps = false;

    public function __construct(array $attributes = [])
    {
        parent::__construct($attributes);
        $this->beforeValidationOnCreate();
    }

    protected function beforeValidationOnCreate()
    {
        $this->create_time = date("Y-m-d H:i:s",time());
        $this->is_del = 0;
    }

    public static function getIdByWords($words,$uid = 0,$auto_add = false)
    {
        $words = trim($words);
        $model = self::where("kw_name",$words)->first();
        if ($model) {
            if ($auto_add) {
                $model->used_count += 1;
                $model->update();
            }
            return $model;
        }
        if ($auto_add == true) {
            $model = new self;
            $model->kw_name = $words;
            $model->uid = $uid;
            $model->follow_count = 0;
            $model->used_count = 1;
            $model->recommend = 0;
            $model->save();
            return $model;
        } else {
            return false;
        }
    }


}