<?php

namespace App\Member\Model;

use App\Traits\Models;
use \Illuminate\Database\Eloquent\Model;

class User extends Model
{
    use Models;
    const ROLE_NOMAL = 0;
    const ROLE_PHOTOGRAPHER = 1;
    const ROLE_MASTER = 2;
    const ROLE_NAME = [
        self::ROLE_NOMAL => "会员",
        self::ROLE_PHOTOGRAPHER => "摄影师",
        self::ROLE_MASTER=> "达人"
    ];

    protected $table = "myp_user";

    const fields = [
        "id","id as uid","mobile","nickname","avatar","is_del","role",
        "access_token","device_token","city_id_2","city_name_2",
        "introduction","user_star","user_star_count","lock",
        "xp_count","gender","country_code"
    ];

    const u_fields = [
        "id","id as uid","mobile","nickname","avatar","is_del","role",
        "lock", "gender","country_code"
    ];

    /**
     * @param $uid
     * @return int|bool
     */
    public static function getUserRole($uid)
    {
        $info = self::find($uid,["role"]);
        if (!$info) {
            return false;
        }
        return $info->role;
    }

    public static function getUserInfo($uid,array $fields = self::fields)
    {
        return self::where("id",$uid)->select($fields)->first();
    }

    public static function getUserIdsByNickname($nickanme)
    {
        return self::where('nickname',$nickanme)->get(['id']);
    }

    public function relation_photographer()
    {
        return $this->hasOne(Photographer::class,"uid","uid")->select(Photographer::fields);
    }

    public function relation_third()
    {
        return $this->hasMany(OAuth::class,"uid","uid")->select(OAuth::fields);
    }
}