<?php

namespace App\Photo\Model;
use App\Traits\Models;
use \Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;
use App\Photo\Model\Details;

class Photo extends Model
{
    use Models;
    protected $table = "myp_xp_set";
    public $timestamps = false;
    protected $fillable = [
        'cover', 'extra_truing_price','count',"uid","pg_id"
    ];

    public function __construct(array $attributes = [])
    {
        parent::__construct($attributes);
        $this->beforeValidationOnCreate();
    }

    public function relation_details()
    {
        return $this->hasMany(Details::class,"xp_id")->select(Details::fields);
    }


    public function beforeValidationOnCreate()
    {
        $this->is_choose    = 0;
        $this->choose_count = 0;
        $this->detail_count = 0;
        $this->choose_time  = date("Y-m-d H:i:s",0);
        $this->is_del = 1;
        $this->cover = " ";
        $this->create_time = date("Y-m-d H:i:s",time());
    }

    public static function newPhoto($data)
    {
        $model = new self;
        $res = $model->fill($data)->save();
        return $res == true ? $model : false;
    }


}