<?php

namespace App\Photo\v1\Controller;
use App\Http\Response\HttpStatus;
use App\Http\Response\Response;
use App\Traits\Controller;
use App\Photo\Model\Details as DetailModel;
use App\Photo\Model\Photo as PhotoModel;
use Illuminate\Http\Request;

class Details extends \Illuminate\Routing\Controller
{

    use Controller;
    protected $query_fields = [
        "xp_id","is_del"
    ];


    public function index($id)
    {
        $query = request()->query();
        $where = $this->filter($query);
        $where['xp_id'] = $id;
        is_null($where) && $where = [];
        $row  = isset($query["size"])?$query["size"]:config("app.default_perpage");
        return Response::success(DetailModel::where($where)->paginate($row)->toArray());
    }

    public function store($id,Request $request)
    {
        try {
            $model = PhotoModel::findOrFail($id);
            $details = DetailModel::add($request->all(),null);
            $res = $model->relation_details()->saveMany($details);
            if ($res) {
                return Response::ok();
            } else {
                return Response::error();
            }
        } catch (ModelNotFoundException $e){
            return Response::error(HttpStatus::HttpNotFound,"选片未找到");
        }
    }

    public function destory($id,$ids)
    {
        try {
            $model = PhotoModel::findOrFail($id);
            $res = $model->relation_details()->whereIn("id",$ids)->delete();
            if ($res) {
                return Response::ok();
            } else {
                return Response::error();
            }
        } catch (ModelNotFoundException $e){
            return Response::error(HttpStatus::HttpNotFound,"选片未找到");
        }
    }
}