<?php
/**
 * Created by PhpStorm.
 * User: zhuangxin
 * Date: 16-9-13
 * Time: 下午5:01
 */

namespace App\Sets\Listeners;


use App\Libraries\ElasticSearch\Search;
use App\Sets\Events\SetsEditedEvent;
use App\Member\Model\User as UserModel;

class SetsSearcherListener
{

    public function handle(SetsEditedEvent $event)
    {
        $model = $event->model;
        /**
         *搜索引擎
         */
        $searcher = Search::getSearcher();
        if ($model->is_del == 1 || $model->is_shelf == $model::SHELF_DOWN || $model->exists == false) {
            $searcher->del(Search::SETS,$model->id);
        } elseif($model->is_del == 0 && $model->is_shelf == $model::SHELF_UP) {
            $keyworks = array_column($model->relation_keywords()->get(["kw_name"])->toArray(),"kw_name");
            $promotion = $model->relation_promotion()->get()->toArray();
            if (!empty($promotion)) {
                $promotion = $promotion[0];
            }
            if (!empty($promotion)) {
                $p_s_t = $promotion['promotion_start_time'];
                $p_e_t = $promotion['promotion_end_time'];
            } else {
                $p_s_t = "0000-00-00 00:00:00";
                $p_e_t = "0000-00-00 00:00:00";
            }
            $data = [
                'sets_id' => $model->id,
                'title'   => $model->title,
                'kw'      => $keyworks,
                'photographer_name' => UserModel::getUserInfo($model->uid,['nickname'])->nickname,
                'lasttime' => date("Y-m-d H:i:s",time()),
                'is_promotion' => $model->is_promotion,
                'start_time'=> $model->start_time,
                'end_time'  => $model->end_time,
                'promotion_start_time' => $p_s_t,
                'promotion_end_time' => $p_e_t,
            ];
            $searcher->save(Search::SETS,$model->id,$data);
        }
    }

}