<?php

namespace App\Sets\Model;
use App\Traits\Models;
use \Illuminate\Database\Eloquent\Model;

class Keywords extends Model
{
    use Models;
    protected $table = "myp_sets_kw";
    const fields = [
        "id","kw_id","kw_name"
    ];

    public $timestamps = false;

    protected $fillable = [
        "kw_id"
    ];

    public function __construct(array $attributes = [] , $uid = null)
    {
        parent::__construct($attributes);
        if (isset($attributes['kw_name'])) {
            $model = \App\Kw\Model\Keywords::getIdByWords($attributes['kw_name'] , $uid , true);
            $this->kw_id = $model->id;
            $this->kw_name = $model->kw_name;
        }
        $this->beforeValidationOnCreate();
    }

    public function beforeValidationOnCreate()
    {
        $this->is_del = 0;
    }

}