<?php
namespace App\Sets\Validation;

use App\Http\Validation\ValidatorBase as Validator;

class AttachmentValidator extends Validator
{
    protected $validator = [
        'title'   =>  'chinese_length:2,8',
        'count'   =>  'required|integer',
        'spec'    =>  'required|chinese_length:2,12',
    ];

    protected $message  = [
        'title.chinese_length'       =>  '成品名称需在2到8字之间',
        'count.required'             =>  '请输入交付成品数量',
        'count.integer'              =>  '交付成品数量必须是数字',
        'spec.required'              =>  '请输入交付成品规格',
        'spec.chinese_length'        =>  '成品规格需在2到12字之间',
    ];
}