<?php
namespace App\Sets\Validation;

use App\Http\Validation\ValidatorBase as Validator;

class PromotionValidator extends Validator
{
    protected $validator = [
        'promotion_price'  =>  'required|integer',
        'p_order_count'    =>  'required|integer',
        'promotion_start_time'  => 'required',
        'promotion_end_time'    => 'required',
    ];

    protected $message  = [
        'promotion_price.required'   =>  '请输入特惠金额',
        'promotion_price.integer'    =>  '特惠金额必须是数字',
        'p_order_count.required'     =>  '请输入特惠数量',
        'p_order_count.integer'      =>  '特惠数量必须是数字',
        'promotion_start_time.required'   =>  '请输入特惠开始时间',
        'promotion_end_time.required'     =>  '请输入特惠结束时间',
    ];

    public function custom_validate($data)
    {

    }
}