<?php

namespace App\Traits;

trait Controller
{

    static $sql;
    /**
     * 筛选合法参数
     * @param $where
     * @return \__|array
     * @throws \Exception
     */
    public function filter($where)
    {
        if (is_null($where) || empty($where)) {
            return [];
        }
        require app_path("/Functions/underscore.php");
        $query_fields = null;
        isset($this->query_fields) && $query_fields = $this->query_fields;
        is_string($query_fields) && $query_fields = [$query_fields];
        if ($query_fields)
        {
            if (trim($query_fields[0]) == "*") {
                return $where;
            }
            array_push($this->query_fields,"order");
            return __()->pick($where,__()->intersection($this->query_fields,__()->keys($where)));
        }
        return $where;
    }

    public function setDefaultOrder($where)
    {
        $order = isset($where["order"])?$where["order"]:"id-desc";
        $where['order'] = $order;
        return $where;
    }

    public function getOrder($model,&$where)
    {
        if (!empty($model->unionOrders)) {
            return $model;
        }
        if (!isset($where['order'])) {
            $where = $this->setDefaultOrder($where);
        }
        list($field,$sort) = explode("-",$where["order"]);
        try {
            unset($where['order']);
            unset($where['page']);
            unset($where['size']);
        } catch (\Exception $e) {}
        return $model::orderBy($field,$sort);
    }

    public function setBlurSearch($model,$where,$key,$condition = "like")
    {
        $result_model = null;
        $result_model = $this->getOrder($model,$where);
        if (!in_array($key,array_keys($where))) {
            return $result_model->where($where);
        }
        is_string($where[$key]) && $where[$key] = trim($where[$key]);

        switch ($condition) {
            case "like":
                $result_model = $result_model->where($key,"like","%".$where[$key]."%");
                break;
            case "elt":
                $result_model = $result_model->where($key,"<=","'$where[$key]'");
                break;
            case "lt":
                $result_model = $result_model->where($key,"<=","'$where[$key]'");
                break;
            case "gt":
                $result_model = $result_model->where($key,">","'$where[$key]'");
                break;
            case "egt":
                $result_model = $result_model->where($key,">=","'$where[$key]'");
                break;
            case "eq":
                $result_model = $result_model->where($where);
                break;
            case "in":
                $result_model = $result_model->whereIn($key,$where[$key]);
                break;
        }
        unset($where[$key]);
        try {
            $result_model = $result_model->where($where);
        } catch (\Exception $e) {

        }
        $o = clone $result_model;
        self::$sql = $o->toSql();
        return $result_model;
    }

    public function csrf($data,$key) {
       return preg_replace("/<script[^>]*>.*<\/script>/i","",$data[$key]);
    }



}