<?php
/**
 * Created by PhpStorm.
 * User: zhuangxin
 * Date: 16-9-13
 * Time: 下午5:01
 */

namespace App\Works\Listeners;
use App\Works\Events\WorksEditedEvent;
use App\Libraries\ElasticSearch\Search;
use App\Member\Model\User as UserModel;

class WorksSearcherListener
{

    public function handle(WorksEditedEvent $event)
    {
        $works = $event->model;
        $searcher = Search::getSearcher();
        if ($works->is_del == 1 || $works->is_hidden == 1 || $works->exists == false) {
            $searcher->del(Search::WORKS,$works->id);
        } elseif($works->is_del == 0 && $works->is_hidden == 0) {
            $keyworks = array_column($works->relation_keywords()->get(["kw_name"])->toArray(),"kw_name");
            $searcher->save(Search::WORKS , $works->id , [
                'works_id'  => $works->id,
                'name'      => $works->name,
                'kw'        => implode(" ",$keyworks),
                'photographer_name' => UserModel::getUserInfo($works->uid,['nickname'])->nickname,
                'lasttime'  => date("Y-m-d H:i:s",time())
            ]);
        }
    }
}