<?php

namespace App\Works\Model;

use App\Traits\Models;
use \Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class Details extends Model
{
    use Models;
    protected $table = "myp_works_detail";

    protected $fillable = [
        'works_url', 'image_height', 'image_height'
    ];

    public function __construct(array $attributes = [])
    {
        parent::__construct($attributes);
        $this->beforeValidationOnCreate();
    }

    public function beforeValidationOnCreate()
    {
        $this->create_time = date("Y-m-d H:i:s",time());
        $this->is_del = 0;
    }

    public static function del($ids)
    {
        if (!is_array($ids)) {
            $ids = explode(",", $ids);
        }
        $lists = self::whereIn("id",$ids)->get(['id','works_url']);
        if ($lists->count() > 0) {
            foreach ($lists->toArray() as $detail) {
                $detail->delete();
            }
        }
        return true;
    }
}