<?php

namespace App\Works\Model;
use App\Traits\Models;
use \Illuminate\Database\Eloquent\Model;

class Keywords extends Model
{
    use Models;
    protected $table = "myp_works_kw";
    const fields = [
        "id","kw_id","kw_name"
    ];
    protected $fillable = [
        "kw_id","kw_name"
    ];
    public $timestamps = false;
    public function __construct(array $attributes = [],$uid = null)
    {
        parent::__construct($attributes);
        if (!empty($attributes)) {
            $model = \App\Kw\Model\Keywords::getIdByWords($attributes['kw_name'], $uid, true);
            $this->kw_id = $model->id;
            $this->kw_name = $model->kw_name;
        }
        $this->beforeValidationOnCreate();
    }
    public function beforeValidationOnCreate()
    {
        $this->is_del = 0;
        $this->create_time = date("Y-m-d H:i:s",time());
    }
}