<?php

namespace App\Works\v1\Controller;

use App\Http\Response\HttpStatus;
use App\Http\Response\Response;
use App\Works\Model\Works as WorksModel;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Symfony\Component\HttpFoundation\Request;
use App\Works\Model\Details as DetailModel;

class Details extends \Illuminate\Routing\Controller
{
    use \App\Traits\Controller;
    protected $query_fields = [
        "works_id","is_del"
    ];
    /**
     * 样片详情列表
     * @method get
     * @param
     * @param  uid   int    option
     * @param  shelf int    option
     * @param
     */
    public function index($id)
    {
        $query = request()->query();
        $where = $this->filter($query);
        $where['works_id'] = $id;
        is_null($where) && $where = [];
        $row  = isset($query["size"])?$query["size"]:config("app.default_perpage");
        return Response::success(WorksModel::where($where)->paginate($row)->toArray());
    }

    /**
     * 新建
     * @method post
     */
    public function store($id,Request $request)
    {
        $post = $request->all();
        try {
            $works = WorksModel::findOrFail($id , ["id"]);
            $res = $works->images($post);
            if ($res) {
                return Response::ok();
            } else {
                return Response::error();
            }
        } catch (ModelNotFoundException $e){
            return Response::error(HttpStatus::HttpNotFound,"样片未找到");
        }
    }

    /**
     * 删除
     * @method delete
     */
    public function destory($ids)
    {
        $res = DetailModel::del($ids);
        if ($res) {
            return Response::ok();
        } else {
            return Response::error();
        }
    }
}