<?php
use App\Providers\RouteServiceProvider as Provider;

Route::resource ("test"  , \App\Test\Controller\TestController::class);

//套系
Route::group(["prefix" => "sets", 'namespace' => Provider::getNamespace("sets")],function(){
    //套系列表
    Route::get ("/"     , "Sets@index");
    //套系详情
    Route::get ("/{id}" , "Sets@show")->where(['id' => '\d+']);
    //获取关联信息
    Route::get ("/{id}/relation/{relation}" , "Sets@getRelate")->where(['id' => '\d+','relation'=>'\S+']);
    //新增套系
    Route::post("/"     ,  "Sets@store");
    //编辑套系
    Route::put ("/{id}" ,  "Sets@update");
    //删除套系
    Route::delete("/{id}", "Sets@destory");
    /*
    Route::delete("/{id}/hard", "Sets@delete");
    */
    //获取IDS所含ID的所有套系，使用，隔开
    Route::get ("/all/{ids}"     , "Sets@all");
});

//分类
Route::group(["prefix" => "cates", 'namespace' => Provider::getNamespace("cates")],function(){
    //获取所有分类
    Route::get ("/"     , "Category@index");
    //获取子分类
    Route::get ("/{id}/child" , "Category@child")->where(['id' => '\d+']) ;
    //分类详情
    Route::get ("/pretty", "Category@pretty");
});


//样片
Route::group(["prefix" => "works", 'namespace' => Provider::getNamespace("works")],function(){
    //套系列表
    Route::get ("/"     , "Works@index");
    //套系详情
    Route::get ("/{id}" , "Works@show")->where(['id' => '\d+']);
    //获取关联信息
    Route::get ("/{id}/relation/{relation}" , "Works@getRelate")->where(['id' => '\d+','relation'=>'\S+']);

    Route::get ("/{id}/details" , "Details@index")->where(['id' => '\d+']);
    //新增
    Route::post("/"     ,  "Works@store");
     //编辑
    Route::put ("/{id}" ,  "Works@update")->where(['id'=>'\d+']);
     //删除
    Route::delete("/{id}/hard", "Works@destory");
    //删除照片
    Route::delete("/{ids}/image","Details@destory")->where(['ids'=>'\S+']);
    //新增样片里的照片
    Route::post("/{id}/image","Details@store");
    //获取IDS所含ID的所有样片，使用，隔开
    Route::get ("/all/{ids}"     , "Works@all");
});


//身份认证
Route::group(["prefix" => "ident", 'namespace' => Provider::getNamespace("ident")],function(){
    Route::post("/{id}"     ,  "Ident@store")->where(['id' => '\d+']);

});

//用户
Route::group(["prefix" => "user", 'namespace' => Provider::getNamespace("member")],function(){
    Route::get("/{id}"     ,  "User@show")->where(['id' => '\d+']);
    Route::get("/auth/{code?}" ,"User@code");
    Route::get("/show/{code}" ,"User@getUserByHashCode")->where(['code' => '\S+']);
    Route::get("/search" ,"User@search");
    Route::get("/getid/{code?}"  ,"User@getUserIdByHashCode");
    Route::get("/u/{id?}"  ,"User@thirdView");
});


//攻略
Route::group(["prefix" => "art", 'namespace' => Provider::getNamespace("article")],function(){
    Route::get("/"     ,  "Article@index");
    Route::put("/{id}"     ,"Article@update")->where(['id' => '\d+']);
    Route::post("/"     ,  "Article@store");
    Route::get("/{id}"     ,"Article@show")->where(['id' => '\d+']);
    Route::get ("/{id}/relation/{relation}" , "Article@getRelate")->where(['id' => '\d+','relation'=>'\S+']);
});

//选片
Route::group(["prefix" => "photo", 'namespace' => Provider::getNamespace("photo")],function(){
    Route::get("/"     ,  "Photo@index");
    Route::post("/"     , "Photo@store");
    Route::delete("/{id}", "Photo@destory")->where(['id' => '\d+']);
    Route::put("/{id}"  ,  "Photo@update")->where(['id' => '\d+']);
    Route::post("/{id}"   ,  "Details@store")->where(['id' => '\d+']);
    Route::delete("/{id}/{ids}"  , "Details@destory");
    Route::get("/{id}",     "Photo@show")->where(['id' => '\d+']);
    Route::get("/{id}/list", "Details@index")->where(['id' => '\d+']);
});


//城市
Route::group(["prefix" => "city", 'namespace' => Provider::getNamespace("city")],function(){
    Route::get("/"     ,  "City@index");
    Route::get("/travel" ,  "City@travel");
    Route::get("/{id}/parent","City@parent");
    Route::get("/{id}" ,  "City@show")->where(['id'=>'\d+']);
});

//关键词
Route::group(["prefix" => "keywords", 'namespace' => Provider::getNamespace("kw")],function(){
    Route::get("/"     ,  "Keywords@index");
    Route::get("/{id}" ,  "Keywords@show");
});